from math import sin, cos, pi

def normale(x0,y0,z0,x1,y1,z1,x2,y2,z2):
    vx1,vy1,vz1=x1-x0,y1-y0,z1-z0
    vx2,vy2,vz2=x2-x0,y2-y0,z2-z0
    nx,ny,nz=vy1*vz2-vz1*vy2 , vz1*vx2-vx1*vz2 , vx1*vy2-vy1*vx2
    # on normalise
    nl=(nx**2+ny**2+nz**2)**0.5
    nx,ny,nz= nx/nl , ny/nl , nz/nl
    c=[nx,ny,nz]
    return c

def coordonnees (r, angle, delta):
    global pas
    z=int((pas*angle/(2*pi)+delta)*100)/100
    x=int(r*cos(angle)*100)/100
    y=int(r*sin(angle)*100)/100
    c=[x,y,z]
    return c


R0, R1 = 4, 6
pas=7
biais, plat = 1, 2
nbfacette=72
angle0=2*pi/nbfacette
nbtour=10
v=[]
f=[]
t=4*nbfacette
for i in range(nbtour*nbfacette):
    angle=i*2*pi/nbfacette
    c=coordonnees(R0,angle,0)
    v.append(c)
    c=coordonnees(R1,angle,biais)
    v.append(c)
    c=coordonnees(R1,angle,biais+plat)
    v.append(c)
    c=coordonnees(R0,angle,2*biais+plat)
    v.append(c)
    ii=i*4+1
    f.append([ii,ii+1,ii+4])
    f.append([ii+1,ii+5,ii+4])
    
    f.append([ii+1,ii+2,ii+6])
    f.append([ii+1,ii+6,ii+5])

    f.append([ii+2,ii+3,ii+6])
    f.append([ii+3,ii+7,ii+6])

    f.append([ii+3,ii+t,ii+t+4])
    f.append([ii+3,ii+t+4,ii+7])
    
i=nbtour*nbfacette
angle=i*2*pi/nbfacette
c=coordonnees(R0,angle,0)
v.append(c)
c=coordonnees(R1,angle,biais)
v.append(c)
c=coordonnees(R1,angle,biais+plat)
v.append(c)
c=coordonnees(R0,angle,2*biais+plat)
v.append(c)


    
for i in range(nbtour*nbfacette,nbtour*nbfacette+2):
    angle=i*2*pi/nbfacette

    c=coordonnees(R0,angle,pas)
    v.append(c)

nbv=len(v)-1

txt="o vis\n"
for t in v:
    txt+="v "+str(t[0])+" "+str(t[1])+" "+str(t[2])+"\n"
for t in f:
    t0=t[0]
    if t0<nbv:
        t1=t[1]
        if t1<nbv:
            t2=t[2]
            if t2<nbv:
                txt+="f "+str(t[0])+" "+str(t[1])+" "+str(t[2])+"\n"
    




dest = open("C:/Python38/spire01.obj", "w")
dest.write(txt)
dest.close()
    
    
                
    
    

